﻿using System;
using System.Collections.Generic;

namespace StoreManager.Common.U_DataView
{
    public class U_ReportCategory : UC_IConvertable
    {
        private const int cn = 7;   //number of columns

        public readonly string PLU;
        public readonly string name;
        public readonly string Item_Count;
        public readonly decimal Item_Sold;
        public readonly decimal Item_Return;
        public readonly string status;
        public readonly string countable;

        public U_ReportCategory()
        {
            //for compatibility with UC_BaseList only!
        }

        public U_ReportCategory(string plu, string name, string item_count,decimal item_sold, decimal item_return, string status,string countable)
        {
            this.PLU = plu;
            this.name = name;
            this.Item_Count = item_count;
            this.Item_Sold = item_sold;
            this.Item_Return = item_return;
            this.status = status;
            this.countable = countable;

            //for compatibility with UC_BaseList only!
        }

        public object[] GetObjArray()
        {
            object[] objArray = new object[cn];

            objArray[0] = this.PLU;
            objArray[1] = this.name;
            objArray[2] = this.Item_Count;
            objArray[3] = this.Item_Sold;
            objArray[4] = this.Item_Return;
            objArray[5] = this.status;
            objArray[6] = this.countable;
            return objArray;
        }

        public int GetColumnsCounter()
        {
            return cn;
        }

        public List<string> GetHeaderList()
        {
            List<string> headerList = new List<string>();

            //headerList.Add("");
            headerList.Add(Common.ResMgr.ResManager.GetString("dtgHeader_SKU"));
            headerList.Add(Common.ResMgr.ResManager.GetString("dtgHeader_DESCRIPTION"));
            headerList.Add(Common.ResMgr.ResManager.GetString("dtgHeader_AvailableQTY"));
            headerList.Add(Common.ResMgr.ResManager.GetString("dtgHeader_SOLD_QTY"));
            headerList.Add(Common.ResMgr.ResManager.GetString("dtgHeader_RETURN_QTY"));
            headerList.Add(Common.ResMgr.ResManager.GetString("dtgHeader_STATUS")); 

            headerList.Add("Countable");
            return headerList;
        }

    }
}
