﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace StoreManager.Common.U_DataView
{
    public enum U_ReportCategoryCmpType
    {
        PLU, name, Item_Count, Item_Sold, Item_Return, status,Countable,
        None    // None type must be the last 
    }
    public class U_ReportCategoryCmp : IComparer<U_ReportCategory>
    {
        public U_ReportCategoryCmpType sortType;
        public SortOrder sortOrder;

        public U_ReportCategoryCmp(U_ReportCategoryCmpType sType, SortOrder sOrder)
        {
            this.sortType = sType;
            this.sortOrder = sOrder;
        }

        public static bool isCompatible(int Value)
        {
            return ((Value >= 0) && (Value <= (int)U_ReportCategoryCmpType.None));
        }

        public decimal NA2Zero(string temp)
        {
            if (temp == "NA")
                return 0;
            else
                return Convert.ToDecimal(temp);
        }
        public int Compare(U_ReportCategory x, U_ReportCategory y)
        {
            int cmpResult = 0;
            int cmpFactor = 1;

            switch (this.sortType)
            {
                case U_ReportCategoryCmpType.PLU:
                    cmpResult = x.PLU.CompareTo(y.PLU);
                    break;

                case U_ReportCategoryCmpType.name:
                    cmpResult = x.name.CompareTo(y.name);
                    break;

                case U_ReportCategoryCmpType.Item_Count:
                    cmpResult = NA2Zero(x.Item_Count).CompareTo(NA2Zero(y.Item_Count));
                    break;

                case U_ReportCategoryCmpType.Item_Sold:
                    cmpResult = Convert.ToDecimal(x.Item_Sold).CompareTo(Convert.ToDecimal(y.Item_Sold));
                    break;

                case U_ReportCategoryCmpType.Item_Return:
                    cmpResult = Convert.ToDecimal(x.Item_Return).CompareTo(Convert.ToDecimal(y.Item_Return));
                    break;

                case U_ReportCategoryCmpType.status:
                    cmpResult = x.status.CompareTo(y.status);
                    break;
            }

            if (this.sortOrder != SortOrder.Descending)
                cmpFactor = -1;

            return cmpResult * cmpFactor;
        }

    }
}
